require "procs/version"

module Procs
	class ProcessInfo
		attr_reader :pid
		attr_reader :ppid
		attr_reader :cmd
		def initialize(pid, ppid, cmd)
			@pid  = pid.to_i
			@ppid = ppid.to_i
			@cmd  = cmd.strip
		end

		def kill
			Process::kill('KILL', self.pid)
			begin
				Process::wait(self.pid)
			rescue Errno::ECHILD => err
			end
		end

		def killtree
			self.childs.each{|c| c.killtree}
			self.kill
		end
	
		def ProcessInfo::info(pid)
			p,pp,c=`ps p #{pid} -o pid,ppid,cmd`.scan(/(\d+)\s+(\d+)\s+(.*)$/)[0]
			ProcessInfo.new p.to_i, pp.to_i, c
		end

		def childs
			Procs::childs(self.pid)
		end
	
		def to_i
			self.pid
		end
	
		def to_s
			'<Process: pid=%s, ppid=%s, cmd=%s>'%[self.pid, self.ppid, self.cmd]
		end
		def inspect
			'<Process: pid=%s, ppid=%s, cmd=%s>'%[self.pid, self.ppid, self.cmd]
		end
	end

	def self::pinfo(pid)
		ProcessInfo::info(pid)
	end

    def self::childs(pid = Process::pid)
        ps=`ps ax -o pid,ppid,cmd|grep -v 'ps ax'`.scan(/(\d+)\s+(\d+)\s+(.*)$/)
        ps.select{|p,pp,c| pp.to_i == pid}.map{|p,pp,c| ProcessInfo.new(p.to_i,pp.to_i,c)}
    end

	def self::kill_childs(pid = Process::pid)
		self.childs.each{|c| c.killtree}.size
	end
													 
end
